package map;


import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.util.List;

import entity.Bat;
import entity.Boss;
import entity.Monster;
import environnement.Coordonnees;
import environnement.HitBox;
import jeu.Jeu;
import loaders.LoadSave;


public class LevelManager {


	private BufferedImage[] levelSprite;
	private Level levelOne;
	private Level levelTwo;
	private List<BufferedImage> obstacleImage = new ArrayList<>();
	private static int indexBoss;

	public LevelManager() {
		importOutsideSprites();
		levelOne = new Level(LoadSave.GetLevelData(LoadSave.LEVEL_ONE));
		//levelTwo = new Level(LoadSave.GetLevelData(LoadSave.LEVEL_TWO));
	}

	private BufferedImage[] importOutsideSprites() {
		BufferedImage img = LoadSave.GetSpriteAtlas(LoadSave.LEVEL_SPRITES);
		levelSprite = new BufferedImage[16];

		//Pour les sprites de chaque bloc
		//longs blocs de 17 de hauteur
		levelSprite[0] = img.getSubimage(0, 32, 32, 544);
		//Blocs de 3 pixels de hauteur
		levelSprite[1] = img.getSubimage( 32,  32, 32, 96);
		//Blocs de 2 de hauteur
		levelSprite[2] = img.getSubimage(2 * 32, 32, 32, 64);
		//bloc de 2 de longueur
		levelSprite[3] = img.getSubimage(3 * 32, 32, 64, 32);
		//Bloc de 3 de longeur
		levelSprite[4] = img.getSubimage(5 * 32, 32, 96, 32);
		//Coffres
		levelSprite[5] = img.getSubimage(3 * 32, 2 * 32, 32, 32);
		//Long bloc de 7 de longueur
		//levelSprite[6] = img.getSubimage(32, 5 * 32, 224, 32);
		//Porte du boss
		levelSprite[7] = img.getSubimage(4 * 32, 2 * 32, 32, 96);
		//Terre verticale de 6 de hauteur
		levelSprite[8] = img.getSubimage(8 * 32, 32, 32, 192);
		//Terre horizontale de 7 de longueur
		levelSprite[9] = img.getSubimage(32, 6 * 32, 224, 32);
		//longs blocs de 20 de hauteur
		levelSprite[10] = img.getSubimage(9 * 32, 32, 32, 640);

		//Specifique au niveau 2 :

		//bloc de 20 de longueur
		levelSprite[11] = img.getSubimage(0, 0, 640, 32);
		//bloc de 9 de longueur
		levelSprite[12] = img.getSubimage(10 * 32, 32, 288, 32);
		//Bloc de 5 de hauteur
		levelSprite[13] = img.getSubimage(12 * 32, 2 *32, 32, 160);
		//Bloc de 9 de hauteur
		levelSprite[14] = img.getSubimage(11 * 32, 2 * 32, 32, 288);
		//Bloc de 12 de hauteur
		levelSprite[15] = img.getSubimage(10 * 32, 2 * 32, 32, 384);
		/*for (int j = 0; j < 2; j++)
			for (int i = 0; i < 9; i++) {
				int index = j * 9 + i;
				levelSprite[index] = img.getSubimage(i * 32, j * 32, 32, 32);
			}*/
		return levelSprite;
	}



	public List<Obstacle> generateObstacleTable() {
		List<Obstacle> obstacleList = new ArrayList<>();
		BufferedImage[] tabImages = importOutsideSprites();
		for (int j = 0; j < Jeu.TILES_IN_HEIGHT; j++){
			for (int i = 0; i < Jeu.TILES_IN_WIDTH; i++) {
				int index = levelOne.getSpriteIndex(i, j);

				//Index selon la couleur associée au bloc
				//longs blocs de 17 de hauteur
				if (index==20) {
					obstacleList.add(new Obstacle(new HitBox(new Coordonnees(Jeu.TILES_SIZE * i+Jeu.TILES_SIZE/2, Jeu.TILES_SIZE * j-17*Jeu.TILES_SIZE/2), 17*Jeu.TILES_SIZE, 1*Jeu.TILES_SIZE)));
					obstacleImage.add(tabImages[0]);
				}
				//Blocs de 3 pixels de hauteur
				if (index==21) {
					obstacleList.add(new Obstacle(new HitBox(new Coordonnees(Jeu.TILES_SIZE * i+Jeu.TILES_SIZE/2, Jeu.TILES_SIZE * j-3*Jeu.TILES_SIZE/2), 3*Jeu.TILES_SIZE, 1*Jeu.TILES_SIZE)));
					obstacleImage.add(tabImages[1]);
				}
				//Blocs de 2 de hauteur
				if (index==22) {
					obstacleList.add(new Obstacle(new HitBox(new Coordonnees(Jeu.TILES_SIZE * i+Jeu.TILES_SIZE/2, Jeu.TILES_SIZE * j-2*Jeu.TILES_SIZE/2), 2*Jeu.TILES_SIZE, 1*Jeu.TILES_SIZE)));
					obstacleImage.add(tabImages[2]);
				}
				//bloc de 2 de longueur
				if (index==23) {
					obstacleList.add(new Obstacle(new HitBox(new Coordonnees(Jeu.TILES_SIZE * i+2*Jeu.TILES_SIZE/2, Jeu.TILES_SIZE * j-Jeu.TILES_SIZE/2), 1*Jeu.TILES_SIZE, 2*Jeu.TILES_SIZE)));
					obstacleImage.add(tabImages[3]);
				}
				//Bloc de 3 de longeur
				if (index==25) {
					obstacleList.add(new Obstacle(new HitBox(new Coordonnees(Jeu.TILES_SIZE * i+3*Jeu.TILES_SIZE/2, Jeu.TILES_SIZE * j-Jeu.TILES_SIZE/2), 1*Jeu.TILES_SIZE, 3*Jeu.TILES_SIZE)));
					obstacleImage.add(tabImages[4]);
				}
				//Porte du boss

				if (index==44) {
					//obstacleList.add(new Obstacle(new HitBox(new Coordonnees(Jeu.TILES_SIZE * i+1*Jeu.TILES_SIZE/2, Jeu.TILES_SIZE * j-3*Jeu.TILES_SIZE/2), 3*Jeu.TILES_SIZE, 1*Jeu.TILES_SIZE-1)));
					obstacleImage.add(tabImages[7]);
				}
				//Terre verticale de 6 de hauteur
				if (index==28) {
					obstacleList.add(new Obstacle(new HitBox(new Coordonnees(Jeu.TILES_SIZE * i+1*Jeu.TILES_SIZE/2, Jeu.TILES_SIZE * j-6*Jeu.TILES_SIZE/2), 6*Jeu.TILES_SIZE, 1*Jeu.TILES_SIZE)));
					obstacleImage.add(tabImages[8]);
				}
				//Terre horizontale de 7 de longueur
				if (index==121) {
					obstacleList.add(new Obstacle(new HitBox(new Coordonnees(Jeu.TILES_SIZE * i+7*Jeu.TILES_SIZE/2, Jeu.TILES_SIZE * j-1*Jeu.TILES_SIZE/2), 1*Jeu.TILES_SIZE, 7*Jeu.TILES_SIZE)));
					obstacleImage.add(tabImages[9]);
				}
				//Long bloc de 7 de longueur
				if (index==101) {
					obstacleList.add(new Obstacle(new HitBox(new Coordonnees(Jeu.TILES_SIZE * i+7*Jeu.TILES_SIZE/2, Jeu.TILES_SIZE * j-Jeu.TILES_SIZE/2), 1*Jeu.TILES_SIZE, 7*Jeu.TILES_SIZE)));
					obstacleImage.add(tabImages[6]);
				}
				//longs blocs de 20 de hauteur
				if (index==29) {
					obstacleList.add(new Obstacle(new HitBox(new Coordonnees(Jeu.TILES_SIZE * i+Jeu.TILES_SIZE/2, Jeu.TILES_SIZE * j-20*Jeu.TILES_SIZE/2), 20*Jeu.TILES_SIZE, 1*Jeu.TILES_SIZE)));
					obstacleImage.add(tabImages[10]);
					System.out.println(i);
				}

				//Specifique au niveau 2 :

				//bloc de 20 de longueur
				if (index==0) {
					obstacleList.add(new Obstacle(new HitBox(new Coordonnees(Jeu.TILES_SIZE * i+20*Jeu.TILES_SIZE/2, Jeu.TILES_SIZE * j-1*Jeu.TILES_SIZE/2), 1*Jeu.TILES_SIZE, 20*Jeu.TILES_SIZE)));
					obstacleImage.add(tabImages[11]);
				}
				//bloc de 9 de longueur
				if (index==30) {
					obstacleList.add(new Obstacle(new HitBox(new Coordonnees(Jeu.TILES_SIZE * i+9*Jeu.TILES_SIZE/2, Jeu.TILES_SIZE * j-1*Jeu.TILES_SIZE/2), 1*Jeu.TILES_SIZE, 9*Jeu.TILES_SIZE)));
					obstacleImage.add(tabImages[12]);
				}
				//Bloc de 5 de hauteur
				if (index==52) {
					obstacleList.add(new Obstacle(new HitBox(new Coordonnees(Jeu.TILES_SIZE * i+Jeu.TILES_SIZE/2, Jeu.TILES_SIZE * j-5*Jeu.TILES_SIZE/2), 5*Jeu.TILES_SIZE, 1*Jeu.TILES_SIZE)));
					obstacleImage.add(tabImages[13]);
				}
				//Bloc de 9 de hauteur
				if (index==51) {
					obstacleList.add(new Obstacle(new HitBox(new Coordonnees(Jeu.TILES_SIZE * i+Jeu.TILES_SIZE/2, Jeu.TILES_SIZE * j-9*Jeu.TILES_SIZE/2), 9*Jeu.TILES_SIZE, 1*Jeu.TILES_SIZE)));
					obstacleImage.add(tabImages[14]);
				}
				//Bloc de 12 de hauteur
				if (index==50) {
					obstacleList.add(new Obstacle(new HitBox(new Coordonnees(Jeu.TILES_SIZE * i+Jeu.TILES_SIZE/2, Jeu.TILES_SIZE * j-12*Jeu.TILES_SIZE/2), 12*Jeu.TILES_SIZE, 1*Jeu.TILES_SIZE)));
					obstacleImage.add(tabImages[15]);
				}

			}
		}return obstacleList;
	}
	public List<Monster> generateMonsterTable() {
		List<Monster> monsterList = new ArrayList<>();
		for (int j = 0; j < Jeu.TILES_IN_HEIGHT; j++){
			for (int i = 0; i < Jeu.TILES_IN_WIDTH; i++) {
				int index = levelOne.getSpriteIndex(i, j);

				//Monstres à pied
				if (index == 45) {
					monsterList.add(new Monster(new Coordonnees(32 * i + 30 / 2, 32 * j - 62 / 2), 1000, 30, 60, 1, 3));
					System.out.println("ça a bien créé un monstre");
				}
				//chauve-souris
				if (index == 46) {
					monsterList.add(new Bat(new Coordonnees(32 * i + 20 / 2, 32 * j - 30 / 2), 1, 1));
					System.out.println("oui");
				}
				//Boss
				if (index == 47) {
					monsterList.add(new Boss(new Coordonnees(32*i, 32*j-140/2), 500, 32, 96, 3, 30));
					indexBoss = monsterList.size()-1;
				}
			}
		}
		System.out.println(monsterList);
		return monsterList;
	}

	public List<Coffre> generateCoffreTable(){
		List<Coffre> coffreListe = new ArrayList<>();
		
		for (int j = 0; j < Jeu.TILES_IN_HEIGHT; j++){
			for (int i = 0; i < Jeu.TILES_IN_WIDTH; i++) {
				int index = levelOne.getSpriteIndex(i, j);
				//Coffres
				if (index==43) {
					coffreListe.add(new Coffre(new HitBox(new Coordonnees(Jeu.TILES_SIZE * i+Jeu.TILES_SIZE/2, Jeu.TILES_SIZE * j-Jeu.TILES_SIZE/2), Jeu.TILES_SIZE, Jeu.TILES_SIZE)));
				}

			}
		}
		return coffreListe;
	}


	public void update() {

	}

	public Level getCurrentLevel() {
		return levelOne;
	}

	public List<BufferedImage> getObstacleImage() {
		return obstacleImage;
	} 

	public BufferedImage getImageCoffre() {
		return importOutsideSprites()[5];
	}

	public static int getIndexBoss() {
		return indexBoss;
	} 
	
}
